
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE work.Fugue_384_paket.all;

ENTITY Fugue_384 IS
 PORT
	(
		clk,reset, prvi, poslednji: IN STD_LOGIC;
	    rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		cekaj, preuzmi: OUT STD_LOGIC;
		izlaz: OUT STD_LOGIC_VECTOR(383 DOWNTO 0)
	);
END Fugue_384;


ARCHITECTURE shema OF Fugue_384 IS

  SIGNAL stanje_automata: konacni_automat;
  SIGNAL brojac_prva_petlja: INTEGER;
  SIGNAL brojac_druga_petlja: INTEGER;

BEGIN

 PROCESS(clk)
   VARIABLE stanje_var: stanje_niz;
  BEGIN

   IF (reset='1')THEN
	 stanje_automata<= idle;
	 preuzmi<='0';
	 cekaj<='0';
	 izlaz<=(others=>'0'); 
   ELSIF (clk'EVENT AND clk='1' ) THEN
    CASE (stanje_automata) IS
	  WHEN idle =>
		stanje_var:= f_inicijalizacija(iv);
		IF (prvi='1') THEN
		 R_transformacija(rec, stanje_var);
		 IF(poslednji='1')THEN
		  stanje_automata<=G_runda;
		  brojac_prva_petlja<=0;
		  brojac_druga_petlja<=0;
		  cekaj<='1';					
		 ELSE
		  stanje_automata<=R_runda;
		 END IF;
		END IF;
		preuzmi<='0';			
	  WHEN R_runda =>
	   R_transformacija(rec, stanje_var);
	   IF (poslednji='1')THEN
		 stanje_automata<=G_runda;
		 brojac_prva_petlja<=0;
		 brojac_druga_petlja<=0;
		 cekaj<='1';
	   END IF;			
	  WHEN G_runda =>
		IF (brojac_prva_petlja=14) THEN 
		 IF (brojac_druga_petlja<13) THEN
		  G_runda_druga_petlja(stanje_var);
		  brojac_druga_petlja<=brojac_druga_petlja+1;
		 END IF;
		 IF (brojac_druga_petlja=13) THEN
	     FOR i IN 0 TO 3 LOOP
		   stanje_var(i*36+4):= stanje_var(i*36+4) XOR stanje_var(i*36+0);
		   stanje_var(i*36+12):= stanje_var(i*36+12) XOR stanje_var(i*36+0);
		   stanje_var(i*36+24):= stanje_var(i*36+24) XOR stanje_var(i*36+0);
		  END LOOP;
		  rezultat(stanje_var,izlaz);
		  preuzmi<='1';
		  cekaj<='0';
		  stanje_automata<= idle;
		 END IF;
		END IF;
		IF (brojac_prva_petlja<14) THEN
		 G_runda_prva_petlja(stanje_var);
		 brojac_prva_petlja<=brojac_prva_petlja+1;
		END IF;
    END CASE;
   END IF;
  END PROCESS;
 
END shema;
