LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;

PACKAGE Fugue_512_paket IS

 TYPE stanje_niz IS ARRAY (0 TO 143 ) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
 TYPE s_box_tip IS ARRAY(255 DOWNTO 0) OF STD_LOGIC_VECTOR(7 DOWNTO 0);
 TYPE N_tip IS ARRAY (0 TO 255) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
 TYPE kolona_tip IS ARRAY (0 TO 15) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
 TYPE konacni_automat IS (idle, R_runda, G_runda);
 
 FUNCTION f_inicijalizacija (CONSTANT iv: STD_LOGIC_VECTOR) RETURN stanje_niz;
 
 PROCEDURE tix(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz); 
 PROCEDURE ror3( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE cmix( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE s_box_zamena( VARIABLE element_stanja: INOUT STD_LOGIC_VECTOR(7 DOWNTO 0));
 PROCEDURE s_box_zamena_4x4( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE mnozenje( CONSTANT bajt1: IN STD_LOGIC_VECTOR(7 DOWNTO 0); VARIABLE bajt2: IN STD_LOGIC_VECTOR (7 DOWNTO 0); VARIABLE izlaz: OUT STD_LOGIC_VECTOR (7 DOWNTO 0));
 PROCEDURE super_mix( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE R_transformacija(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE G_runda_prva_petlja( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE ror8( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE ror9( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE G_runda_druga_petlja( VARIABLE stanje: INOUT stanje_niz);
 PROCEDURE rezultat( VARIABLE stanje: IN stanje_niz; SIGNAL izlaz: OUT STD_LOGIC_VECTOR(511 DOWNTO 0));
 
 CONSTANT iv: STD_LOGIC_VECTOR (511 DOWNTO 0):= X"9010bba7a7a999bce479d955d50e2474c0d1b8c63db445f36b00cb8ab1057fc7a2ef930570c632f89834386cac3c9940b3c8ba4aecafa8e5ea32fa93530a723b";
 CONSTANT s_box: s_box_tip:=
 (
X"16", X"bb", X"54", X"b0", X"0f", X"2d", X"99", X"41", X"68", X"42", X"e6", X"bf", X"0d", X"89", X"a1", X"8c", 
X"df", X"28", X"55", X"ce", X"e9", X"87", X"1e", X"9b", X"94", X"8e", X"d9", X"69", X"11", X"98", X"f8", X"e1", 
X"9e", X"1d", X"c1", X"86", X"b9", X"57", X"35", X"61", X"0e", X"f6", X"03", X"48", X"66", X"b5", X"3e", X"70", 
X"8a", X"8b", X"bd", X"4b", X"1f", X"74", X"dd", X"e8", X"c6", X"b4", X"a6", X"1c", X"2e", X"25", X"78", X"ba", 
X"08", X"ae", X"7a", X"65", X"ea", X"f4", X"56", X"6c", X"a9", X"4e", X"d5", X"8d", X"6d", X"37", X"c8", X"e7", 
X"79", X"e4", X"95", X"91", X"62", X"ac", X"d3", X"c2", X"5c", X"24", X"06", X"49", X"0a", X"3a", X"32", X"e0", 
X"db", X"0b", X"5e", X"de", X"14", X"b8", X"ee", X"46", X"88", X"90", X"2a", X"22", X"dc", X"4f", X"81", X"60", 
X"73", X"19", X"5d", X"64", X"3d", X"7e", X"a7", X"c4", X"17", X"44", X"97", X"5f", X"ec", X"13", X"0c", X"cd", 
X"d2", X"f3", X"ff", X"10", X"21", X"da", X"b6", X"bc", X"f5", X"38", X"9d", X"92", X"8f", X"40", X"a3", X"51", 
X"a8", X"9f", X"3c", X"50", X"7f", X"02", X"f9", X"45", X"85", X"33", X"4d", X"43", X"fb", X"aa", X"ef", X"d0", 
X"cf", X"58", X"4c", X"4a", X"39", X"be", X"cb", X"6a", X"5b", X"b1", X"fc", X"20", X"ed", X"00", X"d1", X"53", 
X"84", X"2f", X"e3", X"29", X"b3", X"d6", X"3b", X"52", X"a0", X"5a", X"6e", X"1b", X"1a", X"2c", X"83", X"09", 
X"75", X"b2", X"27", X"eb", X"e2", X"80", X"12", X"07", X"9a", X"05", X"96", X"18", X"c3", X"23", X"c7", X"04", 
X"15", X"31", X"d8", X"71", X"f1", X"e5", X"a5", X"34", X"cc", X"f7", X"3f", X"36", X"26", X"93", X"fd", X"b7", 
X"c0", X"72", X"a4", X"9c", X"af", X"a2", X"d4", X"ad", X"f0", X"47", X"59", X"fa", X"7d", X"c9", X"82", X"ca", 
X"76", X"ab", X"d7", X"fe", X"2b", X"67", X"01", X"30", X"c5", X"6f", X"6b", X"f2", X"7b", X"77", X"7c", X"63" 
);
CONSTANT N: N_tip:=
 (
X"01", X"04", X"07", X"01", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", 
X"00", X"01", X"00", X"00", X"01", X"01", X"04", X"07", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"00", 
X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"07", X"01", X"01", X"04", X"00", X"00", X"01", X"00", 
X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"04", X"07", X"01", X"01", 
X"00", X"00", X"00", X"00", X"00", X"04", X"07", X"01", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", 
X"00", X"01", X"00", X"00", X"00", X"00", X"00", X"00", X"01", X"00", X"04", X"07", X"00", X"01", X"00", X"00", 
X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"00", X"00", X"07", X"01", X"00", X"04", 
X"04", X"07", X"01", X"00", X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"01", X"00", X"00", X"00", X"00", 
X"00", X"00", X"00", X"00", X"07", X"00", X"00", X"00", X"06", X"04", X"07", X"01", X"07", X"00", X"00", X"00", 
X"00", X"07", X"00", X"00", X"00", X"00", X"00", X"00", X"00", X"07", X"00", X"00", X"01", X"06", X"04", X"07", 
X"07", X"01", X"06", X"04", X"00", X"00", X"07", X"00", X"00", X"00", X"00", X"00", X"00", X"00", X"07", X"00", 
X"00", X"00", X"00", X"07", X"04", X"07", X"01", X"06", X"00", X"00", X"00", X"07", X"00", X"00", X"00", X"00", 
X"00", X"00", X"00", X"00", X"04", X"00", X"00", X"00", X"04", X"00", X"00", X"00", X"05", X"04", X"07", X"01", 
X"01", X"05", X"04", X"07", X"00", X"00", X"00", X"00", X"00", X"04", X"00", X"00", X"00", X"04", X"00", X"00", 
X"00", X"00", X"04", X"00", X"07", X"01", X"05", X"04", X"00", X"00", X"00", X"00", X"00", X"00", X"04", X"00", 
X"00", X"00", X"00", X"04", X"00", X"00", X"00", X"04", X"04", X"07", X"01", X"05", X"00", X"00", X"00", X"00" 
);
CONSTANT ired_polinom: STD_LOGIC_VECTOR(14 DOWNTO 0):="000000100011011";

END Fugue_512_paket;

PACKAGE BODY Fugue_512_paket IS

 FUNCTION f_inicijalizacija (CONSTANT iv: STD_LOGIC_VECTOR) RETURN stanje_niz IS
   VARIABLE i: INTEGER RANGE 0 TO 3;
   VARIABLE j: INTEGER RANGE 0 TO 35;
   VARIABLE stanje: stanje_niz;
   VARIABLE iv_var: STD_LOGIC_VECTOR (511 DOWNTO 0);
  BEGIN
   iv_var:= iv;
   FOR i IN 0 TO 3 LOOP
		FOR j IN 0 TO 19 LOOP
			stanje (i*36+j):= X"00";
		END LOOP;
   END LOOP;
   FOR j IN 20 TO 35 LOOP
		FOR i IN 0 TO 3 LOOP
			stanje (i*36+j):= iv_var(511 DOWNTO 504);
			iv_var:= SHL(iv_var, "1000");
		END LOOP;
   END LOOP;
  RETURN stanje;
 END f_inicijalizacija;
  
 PROCEDURE tix(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz) IS
   VARIABLE rec_var: STD_LOGIC_VECTOR(31 DOWNTO 0);
  BEGIN
   rec_var:= rec;
   FOR i IN 0 TO 3 LOOP
		stanje(i*36+10):= stanje(i*36+10) XOR stanje(i*36+0);
   END LOOP;
   FOR i IN 0 TO 3 LOOP
		stanje(i*36+0):=rec_var(31 DOWNTO 24);
		rec_var:= SHL(rec_var,"1000");
   END LOOP;
   FOR i IN 0 TO 3 LOOP
		stanje(i*36+7):= stanje(i*36+7) XOR stanje(i*36+0);
		stanje(i*36+11):= stanje(i*36+11) XOR stanje(i*36+0);
		stanje(i*36+4):= stanje(i*36+4) XOR stanje(i*36+1);
		stanje(i*36+22):= stanje(i*36+22) XOR stanje(i*36+1);
   END LOOP;
 END tix;
   
 PROCEDURE ror3( VARIABLE stanje: INOUT stanje_niz) IS
   VARIABLE novo_stanje: stanje_niz;
  BEGIN
   FOR i IN 0 TO 3 LOOP
		FOR j IN 35 DOWNTO 3 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j-3);
		END LOOP;
		FOR j IN 2 DOWNTO 0 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j+33);
		END LOOP;
   END LOOP;
   stanje:=novo_stanje;
 END ror3;
   
 PROCEDURE cmix( VARIABLE stanje: INOUT stanje_niz) IS
  BEGIN
   FOR i IN 0 TO 3 LOOP
		stanje(i*36+0):= stanje(i*36+0) XOR stanje(i*36+4);
		stanje(i*36+1):= stanje(i*36+1) XOR stanje(i*36+5);
		stanje(i*36+2):= stanje(i*36+2) XOR stanje(i*36+6);
		stanje(i*36+18):= stanje(i*36+18) XOR stanje(i*36+4);
		stanje(i*36+19):= stanje(i*36+19) XOR stanje(i*36+5);
		stanje(i*36+20):= stanje(i*36+20) XOR stanje(i*36+6);
   END LOOP;
 END cmix;
   
 PROCEDURE s_box_zamena( VARIABLE element_stanja: INOUT STD_LOGIC_VECTOR(7 DOWNTO 0)) IS
   VARIABLE indeks: INTEGER RANGE 0 TO 255;
  BEGIN
   indeks:=conv_integer(element_stanja);
   element_stanja:= s_box(indeks);
 END s_box_zamena;
    
 PROCEDURE s_box_zamena_4x4( VARIABLE stanje: INOUT stanje_niz) IS
  BEGIN
	FOR i IN 0 TO 3 LOOP
		FOR j IN 0 TO 3 LOOP
			s_box_zamena(stanje(i*36+j));
		END LOOP;
   END LOOP;
 END s_box_zamena_4x4;
    
 PROCEDURE mnozenje( CONSTANT bajt1: IN STD_LOGIC_VECTOR(7 DOWNTO 0); VARIABLE bajt2: IN STD_LOGIC_VECTOR (7 DOWNTO 0); VARIABLE izlaz: OUT STD_LOGIC_VECTOR (7 DOWNTO 0)) IS
   VARIABLE proizvod,a,b:STD_LOGIC_VECTOR(7 DOWNTO 0); 
  BEGIN
   proizvod:=X"00";
   a:=bajt1;
	b:=bajt2;
	FOR i IN 0 TO 7 LOOP
		IF(b(0)='1')THEN
			proizvod:=proizvod XOR a;
		END IF;
		b:= '0' & b(7 DOWNTO 1);
		IF(a(7)='1')THEN
			a:=(a(6 DOWNTO 0)&'0') XOR X"1B";
		ELSE
			a:=(a(6 DOWNTO 0)&'0');
		END IF;
	END LOOP;
	izlaz:=proizvod;
 END mnozenje;
    
 PROCEDURE super_mix( VARIABLE stanje: INOUT stanje_niz) IS
   VARIABLE kolona: kolona_tip;
   VARIABLE rezultat_mnozenja: STD_LOGIC_VECTOR(7 DOWNTO 0);
   VARIABLE suma: STD_LOGIC_VECTOR(7 DOWNTO 0);
   VARIABLE vrsta_stanja: INTEGER RANGE 0 TO 3;
   VARIABLE kolona_stanja: INTEGER RANGE 0 to 3;
  BEGIN
    FOR i IN 0 TO 3 LOOP
		FOR j IN 0 TO 3 LOOP
			kolona(i+4*j):= stanje(i*30+j);
		END LOOP;
    END LOOP;
    vrsta_stanja:=0;
    kolona_stanja:=0;
    FOR i IN 0 TO 15 LOOP
		suma:="00000000";
		FOR j IN 0 TO 15 LOOP
			mnozenje(N(i*16+j), kolona(j), rezultat_mnozenja);
			suma:= suma XOR rezultat_mnozenja;  
		END LOOP;
		stanje(vrsta_stanja*30+ kolona_stanja):= suma;
		IF (vrsta_stanja=3) THEN
			vrsta_stanja:=0;
			IF (kolona_stanja<3) THEN
				kolona_stanja:=kolona_stanja+1;
			END IF;
		ELSE
			vrsta_stanja:=vrsta_stanja+1;
	  END IF;
    END LOOP;
  END super_mix;
	 
  PROCEDURE R_transformacija(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz) IS
   BEGIN
    tix(rec, stanje);
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
  END R_transformacija;
   
  PROCEDURE G_runda_prva_petlja( VARIABLE stanje: INOUT stanje_niz) IS
   BEGIN
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    ror3(stanje);
    cmix(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
  END G_runda_prva_petlja;
   
  PROCEDURE ror8( VARIABLE stanje: INOUT stanje_niz) IS
    VARIABLE novo_stanje: stanje_niz;
   BEGIN
    FOR i IN 0 TO 3 LOOP
		FOR j IN 35 DOWNTO 8 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j-8);  
		END LOOP;
		FOR j IN 7 DOWNTO 0 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j+28);
		END LOOP;
    END LOOP;
    stanje:=novo_stanje;
  END ror8;
   
  PROCEDURE ror9( VARIABLE stanje: INOUT stanje_niz) IS
    VARIABLE novo_stanje: stanje_niz;
   BEGIN
    FOR i IN 0 TO 3 LOOP
		FOR j IN 35 DOWNTO 9 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j-9);  
		END LOOP;
		FOR j IN 8 DOWNTO 0 LOOP
			novo_stanje(i*36+j):= stanje(i*36+j+27);
		END LOOP;
    END LOOP;
    stanje:=novo_stanje;
  END ror9;
   
  PROCEDURE G_runda_druga_petlja( VARIABLE stanje: INOUT stanje_niz) IS
   BEGIN
    FOR i IN 0 TO 3 LOOP
		stanje(i*36+4):= stanje(i*36+4) XOR stanje(i*36+0);
		stanje(i*36+9):= stanje(i*36+9) XOR stanje(i*36+0);
		stanje(i*36+18):= stanje(i*36+18) XOR stanje(i*36+0);
		stanje(i*36+27):= stanje(i*36+27) XOR stanje(i*36+0);
    END LOOP;
    ror9(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    FOR i IN 0 TO 3 LOOP
		stanje(i*36+4):= stanje(i*36+4) XOR stanje(i*36+0);
		stanje(i*36+10):= stanje(i*36+10) XOR stanje(i*36+0);
		stanje(i*36+18):= stanje(i*36+18) XOR stanje(i*36+0);
		stanje(i*36+27):= stanje(i*36+27) XOR stanje(i*36+0);
    END LOOP;
    ror9(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    FOR i IN 0 TO 3 LOOP
		stanje(i*36+4):= stanje(i*36+4) XOR stanje(i*36+0);
		stanje(i*36+10):= stanje(i*36+10) XOR stanje(i*36+0);
		stanje(i*36+19):= stanje(i*36+19) XOR stanje(i*36+0);
		stanje(i*36+27):= stanje(i*36+27) XOR stanje(i*36+0);
    END LOOP;
    ror9(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
    FOR i IN 0 TO 3 LOOP
		stanje(i*36+4):= stanje(i*36+4) XOR stanje(i*36+0);
		stanje(i*36+10):= stanje(i*36+10) XOR stanje(i*36+0);
		stanje(i*36+19):= stanje(i*36+19) XOR stanje(i*36+0);
		stanje(i*36+28):= stanje(i*36+28) XOR stanje(i*36+0);
    END LOOP;
    ror8(stanje);
    s_box_zamena_4x4(stanje);
    super_mix(stanje);
  END G_runda_druga_petlja;
   
  PROCEDURE rezultat( VARIABLE stanje: IN stanje_niz; SIGNAL izlaz: OUT STD_LOGIC_VECTOR(511 DOWNTO 0)) IS
    VARIABLE brojac: INTEGER RANGE 0 TO 64:= 0;
   BEGIN
    FOR m IN 30 DOWNTO 27 LOOP
		FOR i IN 3 DOWNTO 0 LOOP
			izlaz ((brojac*8 + 7) DOWNTO (brojac*8))<= stanje(i*36+m); 
			brojac:= brojac+1;
		END LOOP;
    END LOOP; 
    FOR l IN 21 DOWNTO 18 LOOP
		FOR i IN 3 DOWNTO 0 LOOP
			izlaz ((brojac*8 + 7) DOWNTO (brojac*8))<= stanje(i*36+l); 
			brojac:= brojac+1;
		END LOOP;
    END LOOP; 
    FOR k IN 12 DOWNTO 9 LOOP
		FOR i IN 3 DOWNTO 0 LOOP
			izlaz ((brojac*8 + 7) DOWNTO (brojac*8))<= stanje(i*36+k); 
			brojac:= brojac+1;
		END LOOP;
	 END LOOP; 
    FOR j IN 4 DOWNTO 1 LOOP
		FOR i IN 3 DOWNTO 0 LOOP
			izlaz ((brojac*8 + 7) DOWNTO (brojac*8))<= stanje(i*36+j); 
			brojac:= brojac+1;
		END LOOP;
    END LOOP; 
  END rezultat;
 
END Fugue_512_paket;