LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;

PACKAGE TIX_paket IS

 TYPE stanje_niz IS ARRAY (0 TO 119 ) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
 TYPE konacni_automat IS (idle, R_runda, G_runda);
 
 FUNCTION f_inicijalizacija (CONSTANT iv: STD_LOGIC_VECTOR) RETURN stanje_niz;
 
 PROCEDURE tix(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz); 
 
 CONSTANT iv: STD_LOGIC_VECTOR (255 DOWNTO 0):= X"e952bdde6671135fe0d4f668d2b0b594f96c621dfbf929de9149e89934f8c248";
 
END TIX_paket;

PACKAGE BODY TIX_paket IS
 
 FUNCTION f_inicijalizacija (CONSTANT iv: STD_LOGIC_VECTOR) RETURN stanje_niz IS
   VARIABLE i: INTEGER RANGE 0 TO 3;
   VARIABLE j: INTEGER RANGE 0 TO 29;
   VARIABLE stanje: stanje_niz;
   VARIABLE iv_var: STD_LOGIC_VECTOR (255 DOWNTO 0);
  BEGIN
   iv_var:= iv;
   FOR i IN 0 TO 3 LOOP
		FOR j IN 0 TO 21 LOOP
			stanje (i*30+j):= X"00";
		END LOOP;
    END LOOP;
    FOR j IN 22 TO 29 LOOP
		FOR i IN 0 TO 3 LOOP
			stanje (i*30+j):= iv_var(255 DOWNTO 248);
			iv_var:= SHL(iv_var, "1000");
		END LOOP;
    END LOOP;
   RETURN stanje;
 END f_inicijalizacija;
  
 PROCEDURE tix(SIGNAL rec: IN STD_LOGIC_VECTOR(31 DOWNTO 0); VARIABLE stanje: INOUT stanje_niz) IS
   VARIABLE rec_var: STD_LOGIC_VECTOR(31 DOWNTO 0);
  BEGIN
   rec_var:= rec;
   FOR i IN 0 TO 3 LOOP
		stanje(i*30+10):= stanje(i*30+10) XOR stanje(i*30+0);
   END LOOP;
   FOR i IN 0 TO 3 LOOP
		stanje(i*30+0):=rec_var(31 DOWNTO 24);
		rec_var:= SHL(rec_var,"1000");
   END LOOP;
   FOR i IN 0 TO 3 LOOP
		stanje(i*30+8):= stanje(i*30+8) XOR stanje(i*30+0);
		stanje(i*30+1):= stanje(i*30+1) XOR stanje(i*30+24);
   END LOOP;
 END tix;
   
END TIX_paket;